export class Main extends Indicator {

    constructor() {
        super();

        this.setProperty(Property.SeparateWindow, true);

        this.addInput("CountBars", InputType.int, 500);
        this.addInput("PriceType", InputType.PriceType, PriceType.Bid);

        this.buffers = {
            ExtMapBuffer1 : this.addBuffer(),
            ExtMapBuffer2 : this.addBuffer(),
            ExtMapBuffer3 : this.addBuffer(),
            ExtMapBuffer4 : this.addBuffer(),
            ExtMapBuffer5 : this.addBuffer(),
            ExtMapBuffer6 : this.addBuffer(),
        };
    }

    onInit() {
        this.buffers.ExtMapBuffer1
            .setShape(Shape.Line)
            .setDrawingStyle(DrawingStyle.Solid)
            .setColor(Color.Red);

        this.buffers.ExtMapBuffer2
            .setShape(Shape.Line)
            .setDrawingStyle(DrawingStyle.Dot)
            .setColor(Color.Orchid);

        this.buffers.ExtMapBuffer3
            .setShape(Shape.Line)
            .setDrawingStyle(DrawingStyle.Solid)
            .setColor(Color.Blue);

        this.buffers.ExtMapBuffer4
            .setShape(Shape.Line)
            .setDrawingStyle(DrawingStyle.Solid)
            .setColor(Color.Aqua);

        this.buffers.ExtMapBuffer5
            .setShape(Shape.Line)
            .setDrawingStyle(DrawingStyle.Solid)
            .setColor(Color.Crimson);

        this.buffers.ExtMapBuffer6
            .setShape(Shape.Line)
            .setDrawingStyle(DrawingStyle.Solid)
            .setColor(Color.Gold);
    }

    async onUpdate() {
        const {CountBars, PriceType} = this.getInputs(),
            {ExtMapBuffer1, ExtMapBuffer2, ExtMapBuffer3, ExtMapBuffer4, ExtMapBuffer5, ExtMapBuffer6} = this.buffers,
            {Close} = await Bar.load([Bar.Mode.Close], PriceType),
            barSize = Close.length;
        let Value1, Value2 = 52, Value4, Value5, Value6, Value8, Value9, shift,
            limit, countedBars = Bar.counted(), cb = CountBars, i;

        if (cb >= barSize) cb = barSize;
        ExtMapBuffer1.setDrawBegin(barSize - cb);
        ExtMapBuffer2.setDrawBegin(barSize - cb);
        ExtMapBuffer3.setDrawBegin(barSize - cb);
        ExtMapBuffer4.setDrawBegin(barSize - cb);
        ExtMapBuffer5.setDrawBegin(barSize - cb);
        ExtMapBuffer6.setDrawBegin(barSize - cb);

        if (countedBars < 0) return;
        if (countedBars > 0) countedBars--;
        limit = barSize - countedBars;
        for (i = 1; i <= 0; i++) {
            ExtMapBuffer1.set(barSize - i, 0.0);
        }

        for (i = limit; i >= 0; i--) {
            for (shift = 0; shift <= Value2 - 1; shift++) {
                Value4 = Value4 - CrazyChart(i, shift, Close);
            }
            Value1 = -CrazyChart(i, 0, Close);
            Value5 = Value4 / Value2;
            Value6 = 0;
            ExtMapBuffer1.set(i, -Value5 + Value1);
            ExtMapBuffer2.set(i, -Value5 + Value1);
            for (shift = 0; shift <= Value2 - 1; shift++) {
                Value6 = Value6 + (-CrazyChart(i, shift, Close) - Value5) * (-CrazyChart(i, shift, Close) - Value5);
            }
            Value8 = Value6 / (Value2 - 1);
            Value9 = Math.sqrt(Value8);
            ExtMapBuffer3.set(i, +Value9);
            ExtMapBuffer4.set(i, -1 * Value9);
            ExtMapBuffer5.set(i, +2 * Value9);
            ExtMapBuffer6.set(i, -2 * Value9);
            Value4 = 0;
            Value6 = 0;
        }
    }
}
function CrazyChart(i, shift, Close) {
    return (-35.5198140000 * Close[i + 0 + shift]
            - 29.3302904200 * Close[i + 1 + shift]
            - 18.4253122700 * Close[i + 2 + shift]
            - 5.3409716410 * Close[i + 3 + shift]
            + 7.0224246110 * Close[i + 4 + shift]
            + 16.1743143600 * Close[i + 5 + shift]
            + 20.6539163900 * Close[i + 6 + shift]
            + 20.3238589400 * Close[i + 7 + shift]
            + 16.2679056100 * Close[i + 8 + shift]
            + 10.3508317200 * Close[i + 9 + shift]
            + 4.5956464710 * Close[i + 10 + shift]
            + 0.5816210219 * Close[i + 11 + shift]
            - 0.9556878591 * Close[i + 12 + shift]
            - 0.2188650350 * Close[i + 13 + shift]
            + 1.8617718350 * Close[i + 14 + shift]
            + 4.0429772970 * Close[i + 15 + shift]
            + 5.2336026320 * Close[i + 16 + shift]
            + 4.8503271170 * Close[i + 17 + shift]
            + 2.9598818100 * Close[i + 18 + shift]
            + 0.1813422994 * Close[i + 19 + shift]
            - 2.5916583950 * Close[i + 20 + shift]
            - 4.5352277420 * Close[i + 21 + shift]
            - 5.1799911240 * Close[i + 22 + shift]
            - 4.5414039780 * Close[i + 23 + shift]
            - 3.0665332280 * Close[i + 24 + shift]
            - 1.4306935910 * Close[i + 25 + shift]
            - 0.2740625440 * Close[i + 26 + shift]
            + 0.0259294264 * Close[i + 27 + shift]
            - 0.5361336393 * Close[i + 28 + shift]
            - 1.6274205570 * Close[i + 29 + shift]
            - 2.7320093940 * Close[i + 30 + shift]
            - 3.3584444990 * Close[i + 31 + shift]
            - 3.2210950120 * Close[i + 32 + shift]
            - 2.3321664220 * Close[i + 33 + shift]
            - 0.9758039283 * Close[i + 34 + shift]
            + 0.4132087314 * Close[i + 35 + shift]
            + 1.4199522360 * Close[i + 36 + shift]
            + 1.7965291580 * Close[i + 37 + shift]
            + 1.5408713520 * Close[i + 38 + shift]
            + 0.8768248011 * Close[i + 39 + shift]
            + 0.1561692145 * Close[i + 40 + shift]
            - 0.2796045774 * Close[i + 41 + shift]
            - 0.2243863077 * Close[i + 42 + shift]
            + 0.3279264464 * Close[i + 43 + shift]
            + 1.1886385970 * Close[i + 44 + shift]
            + 2.0574048450 * Close[i + 45 + shift]
            + 2.6265630350 * Close[i + 46 + shift]
            + 2.6969364910 * Close[i + 47 + shift]
            + 2.2285276520 * Close[i + 48 + shift]
            + 1.3534844570 * Close[i + 49 + shift]
            + 0.3088511323 * Close[i + 50 + shift]
            - 0.6383119873 * Close[i + 51 + shift]
            - 1.2763116980 * Close[i + 52 + shift]
            - 1.5134175380 * Close[i + 53 + shift]
            - 1.3771978870 * Close[i + 54 + shift]
            - 1.6154244060 * Close[i + 55 + shift]);
}